package org.gcube.portlets.user.workspace.client.interfaces;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.gcube.portlets.user.workspace.client.ConstantsExplorer.ViewSwitchType;
import org.gcube.portlets.user.workspace.client.model.FileModel;
import org.gcube.portlets.user.workspace.client.model.FolderModel;
import org.gcube.portlets.user.workspace.shared.WorkspaceTrashOperation;


/**
 * @author Francesco Mangiacrapa francesco.mangiacrapa@isti.cnr.it
 *
 */
//Implements this interface to receive events by tree async
public interface SubscriberInterface {
//	public void rescue(GuiEvent event);
//	public void renameItem(FileModel item, String newName, String extension);
//	public void deleteItem(FileModel item);
//	void addFolder(FolderModel itemFolder);
	void addedFile(String itemIdentifier, FileModel parent);
	void selectedItem(FileModel item, List<FileModel> parents);
	void expandFolderItem(FolderModel itemFolder);
	void setParentItemSelected(ArrayList <FileModel> listParents);	
	boolean renameItem(String itemIdentifier, String newName, String extension);
	boolean deleteItem(String itemIdentifier);
	void addedFolder(String itemIdentifier, FileModel parent);
	void rootLoaded(FileModel root);
	void smartFolderSelected(String folderId, String category);
	void movedItems(String sourceParentIdentifier, FileModel targetParent);
	void switchView(ViewSwitchType type);
	void refreshFolder(FileModel fileModel, boolean forceRefreshContent, boolean forceRefreshBreadcrumb);
//	void updatePrevieMessage(String fromLogin, String subject, String date, String body, List<FileModel> attachs);
	
	void createNewMessage(HashMap<String, String> hashAttachs);
	/**
	 * @param itemIdentifier
	 */
	void fileDownloaded(String itemIdentifier);
	/**
	 * 
	 */
	void viewSessionExpiredPanel();
	/**
	 * @param parentId 
	 * @param isTreeRefreshable 
	 * 
	 */
	void pasteEventIsCompleted(boolean isTreeRefreshable, String parentId);
	/**
	 * 
	 */
	void copyEventIsCompleted();

	/**
	 * @param trashOperation
	 * @param targetFileModel
	 */
	void trashEvent(WorkspaceTrashOperation trashOperation, List<FileModel> targetFileModels);
	
	/**
	 * @param vreFolderId
	 */
	void updatedVREPermissions(String vreFolderId);
	
	/**
	 * 
	 * @param oldId
	 * @param newId
	 */
	void changedFileModelId(String oldId, String newId);
	
	void updateWorksapaceSize(boolean delayCall);
	
}
